<template>
  <div id="commentMsg">
    <a-empty v-if="dataLoaded && commentList.length === 0" description="暂无留言内容"/>
    <comment v-for="(item1, index) in commentList"
             :key="'parent-' + index"
             :comment="item1"
             @replySwitch="replySwitch">
      <!-- 二层留言 -->
      <template slot="childComment" v-if="!isEmpty(item1.replies)">
        <comment v-for="(item2, index) in item1.replies"
                 :key="'children-' + index"
                 :comment="item2"
                 @replySwitch="replySwitch"></comment>
      </template>
    </comment>
  </div>
</template>

<script>
import Comment from "./Comment";
import {mapState} from "vuex";

export default {
  name: "CommentMessage",
  components: {
    Comment
  },

  computed: {
    ...mapState('discuss', ['commentList', 'dataLoaded'])
  },
  methods: {
    isEmpty(ls) {
      return !ls || ls.length === 0;
    },

    replySwitch(id1, id2) {
      if (id2) {
        this.commentList.forEach(item => {
          if (item.comment_id === id2) {
            item.replies.forEach(_item => {
              if (_item.comment_id === id1) {
                _item.reply = !_item.reply
              } else {
                _item.reply = false
              }
            })
          }
          item.reply = false
        })
      } else {
        this.commentList.forEach(item => {
          if (item.comment_id === id1) {
            item.reply = !item.reply
          } else {
            item.reply = false
          }
          if (item.replies) {
            item.replies.forEach(_item => {
              _item.reply = false
            })
          }
        })
      }
      this.$store.state.discuss.commentList = JSON.parse(JSON.stringify(this.commentList))
    }
  }
};
</script>

<style lang="less" scoped>
#commentMsg {
  padding-bottom: 20px;
}
.head-message {
  font-size: 20px;
  text-align: center;
}
</style>